/*!
 * Author : Matteo Bruni
 * MIT license: https://opensource.org/licenses/MIT
 * Demo / Generator : https://particles.js.org/
 * GitHub : https://www.github.com/matteobruni/tsparticles
 * How to use? : Check the GitHub README
 * v3.1.0
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("@tsparticles/plugin-emitters"), require("@tsparticles/engine"));
	else if(typeof define === 'function' && define.amd)
		define(["@tsparticles/plugin-emitters", "@tsparticles/engine"], factory);
	else {
		var a = typeof exports === 'object' ? factory(require("@tsparticles/plugin-emitters"), require("@tsparticles/engine")) : factory(root["window"], root["window"]);
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, (__WEBPACK_EXTERNAL_MODULE__68__, __WEBPACK_EXTERNAL_MODULE__533__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 533:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__533__;

/***/ }),

/***/ 68:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__68__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  loadEmittersShapePath: () => (/* binding */ loadEmittersShapePath)
});

// EXTERNAL MODULE: external {"commonjs":"@tsparticles/plugin-emitters","commonjs2":"@tsparticles/plugin-emitters","amd":"@tsparticles/plugin-emitters","root":"window"}
var plugin_emitters_root_window_ = __webpack_require__(68);
// EXTERNAL MODULE: external {"commonjs":"@tsparticles/engine","commonjs2":"@tsparticles/engine","amd":"@tsparticles/engine","root":"window"}
var engine_root_window_ = __webpack_require__(533);
;// CONCATENATED MODULE: ./dist/browser/utils.js

const maxAttempts = 100,
  half = 0.5;
function generateRandomPointWithinPath(ctx, path, center, size) {
  let randomPoint = null;
  for (let attempts = 0; attempts < maxAttempts; attempts++) {
    const tmpPoint = {
      x: center.x + (0,engine_root_window_.getRandom)() * size.width - size.width * half,
      y: center.y + (0,engine_root_window_.getRandom)() * size.height - size.height * half
    };
    if (ctx.isPointInPath(path, tmpPoint.x, tmpPoint.y)) {
      randomPoint = tmpPoint;
      break;
    }
  }
  return randomPoint;
}
function generateRandomPointOnPathPerimeter(ctx, path, center, size) {
  let randomPoint = null;
  for (let attempts = 0; attempts < maxAttempts; attempts++) {
    const tmpPoint = {
      x: center.x + (0,engine_root_window_.getRandom)() * size.width - size.width * half,
      y: center.y + (0,engine_root_window_.getRandom)() * size.height - size.height * half
    };
    if (ctx.isPointInStroke(path, tmpPoint.x, tmpPoint.y)) {
      randomPoint = tmpPoint;
      break;
    }
  }
  return randomPoint;
}
;// CONCATENATED MODULE: ./dist/browser/EmittersPathShape.js



const EmittersPathShape_half = 0.5;
class EmittersPathShape extends plugin_emitters_root_window_.EmitterShapeBase {
  constructor(position, size, fill, options) {
    super(position, size, fill, options);
    const ctx = document.createElement("canvas").getContext("2d");
    if (!ctx) {
      throw new Error(`${engine_root_window_.errorPrefix} No 2d context available`);
    }
    this.checkContext = ctx;
    this.points = options.points;
    const pathData = this.points,
      path = new Path2D(),
      offset = {
        x: position.x - size.width * EmittersPathShape_half,
        y: position.y - size.height * EmittersPathShape_half
      };
    for (const [index, point] of pathData.entries()) {
      const coords = {
        x: offset.x + point.x * size.width / engine_root_window_.percentDenominator,
        y: offset.y + point.y * size.height / engine_root_window_.percentDenominator
      };
      if (!index) {
        path.moveTo(coords.x, coords.y);
      } else {
        path.lineTo(coords.x, coords.y);
      }
    }
    const firstIndex = 0,
      firstPathData = pathData[firstIndex];
    if (firstPathData) {
      const coords = {
        x: offset.x + firstPathData.x * size.width / engine_root_window_.percentDenominator,
        y: offset.y + firstPathData.y * size.height / engine_root_window_.percentDenominator
      };
      path.lineTo(coords.x, coords.y);
    }
    this.path = path;
  }
  async init() {}
  async randomPosition() {
    const ctx = this.checkContext,
      position = this.position,
      size = this.size,
      fill = this.fill,
      path = this.path,
      res = fill ? generateRandomPointWithinPath(ctx, path, position, size) : generateRandomPointOnPathPerimeter(ctx, path, position, size);
    return Promise.resolve(res ? {
      position: res
    } : null);
  }
  resize(position, size) {
    super.resize(position, size);
    const pathData = this.points,
      path = new Path2D(),
      offset = {
        x: position.x - size.width * EmittersPathShape_half,
        y: position.y - size.height * EmittersPathShape_half
      };
    for (const [index, point] of pathData.entries()) {
      const coords = {
        x: offset.x + point.x * size.width / engine_root_window_.percentDenominator,
        y: offset.y + point.y * size.height / engine_root_window_.percentDenominator
      };
      if (!index) {
        path.moveTo(coords.x, coords.y);
      } else {
        path.lineTo(coords.x, coords.y);
      }
    }
    const firstIndex = 0,
      firstPathData = pathData[firstIndex];
    if (firstPathData) {
      const coords = {
        x: offset.x + firstPathData.x * size.width / engine_root_window_.percentDenominator,
        y: offset.y + firstPathData.y * size.height / engine_root_window_.percentDenominator
      };
      path.lineTo(coords.x, coords.y);
    }
    this.path = path;
  }
}
;// CONCATENATED MODULE: ./dist/browser/Options/Classes/EmittersPathShapeOptions.js
const defaultPosition = {
  x: 50,
  y: 50
};
class EmittersPathShapeOptions {
  constructor() {
    this.points = [];
  }
  load(data) {
    if (!data) {
      return;
    }
    if (data.points !== undefined) {
      this.points = data.points.map(t => ({
        x: t.x ?? defaultPosition.x,
        y: t.y ?? defaultPosition.y
      }));
    }
  }
}
;// CONCATENATED MODULE: ./dist/browser/EmittersPathShapeGenerator.js


class EmittersPathShapeGenerator {
  generate(position, size, fill, options) {
    const shapeOptions = new EmittersPathShapeOptions();
    shapeOptions.load(options);
    return new EmittersPathShape(position, size, fill, shapeOptions);
  }
}
;// CONCATENATED MODULE: ./dist/browser/index.js

async function loadEmittersShapePath(engine, refresh = true) {
  const emittersEngine = engine;
  emittersEngine.addEmitterShapeGenerator?.("path", new EmittersPathShapeGenerator());
  await emittersEngine.refresh(refresh);
}
})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});